﻿package  
{
	import flash.events.*;
	import flash.display.*;
	import flash.text.TextField;
	
	/**
	 * http://mrl.nyu.edu/~perlin/noise/
	 * http://freespace.virgin.net/hugo.elias/models/m_clouds.htm
	 * @author nicoptere
	 */
	public class Perlin extends Sprite
	{
		private var canvas:BitmapData;
		private var perlinZ:Number = 0;
		public function Perlin() 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			removeEventListener(Event.ADDED_TO_STAGE, init);
			canvas = new BitmapData( 480/4, 230/4+1, true, 0x000000 );
			var bmp:Bitmap = new Bitmap(canvas, "auto", true);
			bmp.x = 10;
			bmp.y = 10;
			bmp.scaleX = 4;
			bmp.scaleY = 4;
			addChild( bmp );
			
			reseed.addEventListener( MouseEvent.CLICK, reseedHandler );
			addEventListener( Event.ENTER_FRAME, oef );
			
			amplitude.addEventListener( MouseEvent.CLICK, updateHandler );
			frequency.addEventListener( MouseEvent.CLICK, updateHandler );
			persistence.addEventListener( MouseEvent.CLICK, updateHandler );
			octaves.addEventListener( MouseEvent.CLICK, updateHandler );
			
			
			reseedHandler( null );
			update();
		}
		
		private function reseedHandler( e:Event ):void
		{
			PerlinNoise.reseed()
			update();
		}
		
		private function oef( e:Event ):void
		{	
			if ( animate.selected )
			{
				perlinZ += animationSpeed.value;
				String( animationSpeed.value );
				update();
			}
		}
		
		private function updateHandler( e:Event ):void
		{
			update();
		}
		
		private function update():void
		{	
			
			PerlinNoise.amplitude = amplitude.value;
			amp.text = String( amplitude.value );
			
			PerlinNoise.frequency = frequency.value;
			freq.text = String( frequency.value );
			
			PerlinNoise.persistence = persistence.value;
			pers.text = String( persistence.value);
			
			PerlinNoise.octaves = octaves.value;
			oct.text = String( octaves.value );
			
			canvas.lock();
			var w:int = canvas.width;
			var h:int = canvas.height;
			var x:int, y:int, a:int;
			for ( y = 0; y < h; y++)
			{
				for ( x = 0; x < w; x++)
				{
					a = PerlinNoise.compute( x, y, perlinZ ) * 0xFF;
					canvas.setPixel32( x, y, ( a << 24 | 0xFFFFFF ) );// a << 8 | a ) );
				}
			}
			canvas.unlock();
		}
	}
}