﻿package  
{
	
	
	/**
	 * http://mrl.nyu.edu/~perlin/noise/
	 * @author nicoptere
	 */
	public class PerlinNoise 
	{
		
		static private var _frequency:Number = 0.01;
		static public function set frequency( value:Number ):void {	_frequency = value;	}
		static public function get frequency():Number { return _frequency; }
		
        static private var _amplitude:Number = 1.0;
		static public function set amplitude( value:Number ):void {	_amplitude = value;	}
		static public function get amplitude():Number { return _amplitude; }
		
        static private var _persistence:Number = 0.6;
		static public function set persistence( value:Number ):void {_persistence = value;	}
		static public function get persistence():Number { return _persistence; }
		
        static private var _octaves:uint = 1;
		static public function set octaves( value:uint ):void {	_octaves = value;	}
		static public function get octaves():uint { return _octaves; }
		
		static private var p:Array;
		
		static public function compute(x:Number, y:Number, z:Number):Number
		{	
			if ( p == null ) reseed();
			
			var _noise:Number = 0;
			var A:Number = _amplitude;
			var F:Number = _frequency;
			
			var i:int;
			for ( i = 0; i < octaves; i++)
			{
				_noise += noise( x * F, y * F, z * F ) * A;
				F *= 2;
				A *= _persistence;
			}
			
			if (_noise < 0)	return 0;
			if (_noise > 1)	return 1;
			return _noise;
		}

		
		static private function noise( x:Number, y:Number, z:Number ):Number
		{
			// find unit cube that contains point
			var X:int = int(x) & 255;
			var Y:int = int(y) & 255;
			var Z:int = int(z) & 255;
			
			// Find relative x, y, z of the point in the cube.
			x -= int(x);
			y -= int(y);
			z -= int(z);
			
			// Compute fade curves for each of x, y, z
			var u:Number = fade( x );
			var v:Number = fade( y );
			var w:Number = fade( z );
			
			// Hash coordinates of the 8 cube corners
			var A:int = p[ X  ] + Y,		AA:int = p[ A ] + Z,			AB:int = p[ A + 1 ] + Z,			
			B:int = p[ X + 1 ] + Y,			BA:int = p[ B ] + Z,			BB:int = p[ B + 1 ] + Z;
			
			
			// And add blended results from 8 corners of cube.
			return lerp(	w, 	lerp(v, lerp(u, grad(p[AA  ], x  , y  , z   ),  grad(p[BA  ], x-1, y  , z   )), 
										lerp(u, grad(p[AB  ], x  , y-1, z   ),  grad(p[BB  ], x-1, y-1, z   ))),
									
								lerp(v, lerp(u, grad(p[AA+1], x  , y  , z-1 ),  grad(p[BA+1], x-1, y  , z-1 )), 
										lerp(u, grad(p[AB + 1], x  , y - 1, z - 1 ), grad(p[BB + 1], x - 1, y - 1, z - 1 ))));
		}
		
		static private function fade(t:Number):Number 
		{ 
			return Math.pow( t, 3 ) * ( t * ( t * 6 - 15) + 10); 
		}
		static private function lerp(t:Number, a:Number, b:Number):Number 
		{ 
			return a + t * (b - a); 
		}
		static private function grad(hash:int, x:Number, y:Number, z:Number):Number
		{
			var h:int = hash & 15;
			
			var u:Number = y;
			if ( h < 8 ) { u = x; };
			
			var v:Number = z;
			if ( h < 4  ){ v = y; }
			if ( h == 12 || h == 14 ){ v = x; }
			
			if( ( h & 1 ) == 0 ) u = -u;
			if ( ( h & 2 ) == 0 ) v = -v;
			return ( u + v );
		}
		
		static public function reseed():void
		{
			
			var length:int = 256;
			var i:int = length;
			p = new Array( length * 2 );
			while ( i-- ) p[ i ] = p[ length + i ] = int( Math.random() * 256 );
			
		}
	}
}